package forum;


import java.util.Vector;
import util.Mensagem;


public class Assunto {
	
	
	private int ID;
	private String titulo;
	private String descricao;
	private int numeroTopicos;
	private int numeroMensagens;
	private Mensagem ultimaMensagem;
	
	private Vector moderadores;
	
	
	public Assunto(String t, String d) {
		this.titulo = t;
		this.descricao = d;		
	}
	
	public Assunto(int id, String t, String d, int nT, int nM, Mensagem ultMen) {
		this.ID = id;
		this.titulo = t;
		this.descricao = d;		
		this.numeroTopicos = nT;
		this.numeroMensagens = nM;
		this.ultimaMensagem = ultMen;
	}
	
		
	
	public String getDescricao() {
		return descricao;
	}
	public Mensagem getUltimaMensagem() {
		return ultimaMensagem;
	}
	public int getID() {
		return ID;
	}
	public int getNumeroMensagens() {
		return numeroMensagens;
	}
	public int getNumeroTopicos() {
		return numeroTopicos;
	}
	public String getTitulo() {
		return titulo;
	}
	public Vector getModeradores() {
		return moderadores;
	}
	
	
	
	public void setDescricao(String descricao) {
		this.descricao = descricao;
	}
	public void setUltimaMensagem(Mensagem ultimaMensagem) {
		this.ultimaMensagem = ultimaMensagem;
	}
	public void setID(int id) {
		this.ID = id;
	}
	public void setNumeroMensagens(int numeroMensagens) {
		this.numeroMensagens = numeroMensagens;
	}
	public void setNumeroTopicos(int numeroTopicos) {
		this.numeroTopicos = numeroTopicos;
	}
	public void setTitulo(String titulo) {
		this.titulo = titulo;
	}
	public void setModeradores(Vector mods) {
		this.moderadores = mods;
	}
		
}
