package forum;


import java.sql.*;
import java.util.Vector;

import util.Mensagem;




public class RepositorioForum implements IRepositorioForum {

	
	private Connection con;
	
	
	
	public RepositorioForum(Connection c) {
		this.con = c;
	}
	
		
	
	

	public void adicionarForum(Forum f) throws SQLException {
		Statement stmt = this.con.createStatement();
		stmt.executeUpdate("INSERT INTO forum VALUES (idForum.nextVal, '" + f.getTitulo() + "', assunto_nested())");
		stmt.close();		
	}

	
	public void adicionarAssunto(int id_forum, Assunto a) throws SQLException {
		Statement stmt = this.con.createStatement();
		stmt.executeUpdate("INSERT INTO THE(SELECT f.assuntos FROM forum f WHERE f.id = "+ id_forum + ")"+
        "VALUES  (idAssunto.nextVal,'"+a.getTitulo()+"','"+a.getDescricao()+"',0,0,-1, topico_assunto_nested())");
		stmt.close();
	}

	
	public void adicionarTopico(int id_forum, int id_assunto, Topico t) throws SQLException {
		Statement stmt = this.con.createStatement();
		stmt.executeUpdate("INSERT INTO THE(SELECT a.topicos FROM THE(SELECT f.assuntos FROM forum f WHERE f.id = "+
				id_forum+") a WHERE a.id = "+id_assunto+") VALUES  (idTopico.nextVal ,'"+t.getTitulo()+"', " +
						"(SELECT REF(u) FROM usuario u WHERE u.login = '"+t.getInicial().getAutor()+"'),0,-1,-1," +
								" mensagem_topico_nested())");

		stmt.executeUpdate("INSERT INTO THE(SELECT t.mensagens FROM THE(SELECT a.topicos FROM THE(SELECT f.assuntos" +
				" FROM forum f WHERE f.id = "+id_forum+") a WHERE a.id = "+id_assunto+") t WHERE t.id = " +
				"(SELECT MAX(t.id) FROM THE(SELECT a.topicos FROM THE(SELECT f.assuntos FROM forum f WHERE f.id = "+
				id_forum+") a WHERE a.id = "+id_assunto+") t) ) VALUES  ('"+t.getInicial().getCorpo()+"', SYSDATE, SYSDATE, " +
				"(SELECT REF(u) FROM usuario u WHERE u.login = '"+t.getInicial().getAutor()+"'), idMensagemTopico.nextVal)");

		stmt.executeUpdate("UPDATE table (SELECT a.topicos FROM THE(SELECT f.assuntos FROM forum f WHERE f.id = "+
				id_forum+") a WHERE a.id = "+id_assunto+") SET ultima_mensagem = idMensagemTopico.currVal, " +
				"numero_mensagens = numero_mensagens + 1 , primeira_mensagem = idMensagemTopico.currVal" +
				" WHERE id = (SELECT MAX(t.id) FROM THE(SELECT a.topicos FROM THE(SELECT f.assuntos FROM forum f WHERE f.id = "+
				id_forum+") a WHERE a.id = "+id_assunto+") t)");

		stmt.executeUpdate("UPDATE table (SELECT f.assuntos FROM forum f WHERE f.id = "+id_forum+")" +
				"SET ultima_mensagem = idMensagemTopico.currVal, numero_mensagens = " +
				"numero_mensagens + 1, topico_ultima_mens = idTopico.currVal WHERE id = "+id_assunto);

		stmt.executeUpdate("UPDATE usuario SET numero_mensagens = numero_mensagens + 1 WHERE login = '"+
				t.getInicial().getAutor()+"'");	
		
		
		stmt.close();
	}       
	
	
	public void adicionarMensagemTopico(int id_forum,int id_assunto,int id_topico,Mensagem m) throws SQLException {
		Statement stmt = this.con.createStatement();
		
		stmt.executeUpdate("INSERT INTO THE(SELECT t.mensagens FROM THE(SELECT a.topicos FROM THE(SELECT f.assuntos" +
				" FROM forum f WHERE f.id = "+id_forum+") a WHERE a.id = "+id_assunto+") t WHERE t.id = " +
				id_topico+" VALUES  ('"+m.getCorpo()+"', SYSDATE, SYSDATE, " +
				"(SELECT REF(u) FROM usuario u WHERE u.login = '"+m.getAutor()+"'), idMensagemTopico.nextVal)");


		stmt.executeUpdate("UPDATE table (SELECT a.topicos FROM THE(SELECT f.assuntos FROM forum f WHERE f.id = "+
				id_forum+") a WHERE a.id = "+id_assunto+") SET ultima_mensagem = idMensagemTopico.currVal, " +
				"numero_mensagens = numero_mensagens + 1  WHERE id = "+id_topico);

		stmt.executeUpdate("UPDATE table (SELECT f.assuntos FROM forum f WHERE f.id = "+id_forum+")" +
				"SET ultima_mensagem = idMensagemTopico.currVal, numero_mensagens = " +
				"numero_mensagens + 1 WHERE id = "+id_assunto);

		stmt.executeUpdate("UPDATE usuario SET numero_mensagens = numero_mensagens + 1 WHERE login = '"+
				m.getAutor()+"'");	
		
		stmt.close();		
	}
	
	

		
	public Vector getForuns() throws SQLException {
		Statement stmt = this.con.createStatement();
		ResultSet rset;
		int id_forum;
		Forum f;
		
		rset = stmt.executeQuery("SELECT id FROM forum");		
		Vector foruns = new Vector();        
        while(rset.next()) {
        	id_forum = rset.getInt(1);        	
        	f = this.procurarForum(id_forum);
        	foruns.addElement(f);	
        }
        stmt.close();			
		return foruns;
	}	
	
	
	public Forum procurarForum(int id_forum) throws SQLException {
		Statement stmt = this.con.createStatement();
		ResultSet rset;
		int id_assunto;
		String titulo;
		Vector assun;
		Assunto a;
		
		rset = stmt.executeQuery("SELECT titulo FROM forum WHERE id = "+ id_forum + ";");
		if(!rset.next()) return null;
	    titulo = rset.getString(1);
    	
    	assun = new Vector();
    	rset = stmt.executeQuery("SELECT a.id FROM THE(SELECT f.assuntos FROM forum f WHERE f.id = "+ id_forum +
    			                 ") a;");
    	while(rset.next()) {
    		id_assunto = rset.getInt(1);
    		a = this.procurarAssunto(id_forum,id_assunto);
    		assun.addElement(a);        		
    	}
	    stmt.close();
	    return new Forum(id_forum,titulo,assun);
	}
	
	
	public Assunto procurarAssunto(int id_forum,int id_assunto) throws SQLException {
		Statement stmt = this.con.createStatement();
			
		ResultSet rset = stmt.executeQuery("SELECT a.* FROM the(select f.assuntos from forum f where f.id = "+id_forum+
				")a where a.id = "+ id_assunto +";");
		if (!rset.next()) return null;		
		String titulo = rset.getString(2);
		String desc = rset.getString(3);
		int numTopicos = rset.getInt(4);
		int numMensagens = rset.getInt(5);
		int id_topico = rset.getInt(7);
		Mensagem m = this.procurarMensagemTopico(id_forum,id_assunto,id_topico,rset.getInt(6));
			     
        stmt.close();	
        
		return new Assunto(id_assunto,titulo,desc,numTopicos,numMensagens,m);		
	}
	
	
	public Mensagem procurarMensagemTopico(int id_forum,int id_assunto,int id_topico,int id_mensagem) throws SQLException {
		Statement stmt = con.createStatement();
		ResultSet rset = stmt.executeQuery("SELECT m.* FROM the(select t.mensagens from the ( select a.topicos from the (" +
				"select f.assuntos from forum f where f.id = "+id_forum+")a where a.id = "+id_assunto+")t " +
						"where t.id = "+ id_topico + ")m where m.id = "+ id_mensagem);
		if(!rset.next()) return null;
		String corpo = rset.getString(1);
    	String data = rset.getString(2);
    	String edit = rset.getString(3);
    	String autor = rset.getString(4);
    	stmt.close();
    	
    	return new Mensagem(id_mensagem,autor,corpo,data,edit);	
	}
	
	
	public Vector getTopicosAssunto(int id_forum, int id_assunto) throws SQLException {
		Statement stmt = con.createStatement();
		int id_topico;
		
		ResultSet rset = stmt.executeQuery("select t.id from the ( select a.topicos from the (select f.assuntos from " +
				"forum f where f.id = "+id_forum+")a where a.id = "+id_assunto+")t ORDER BY t.ultima_mensagem.data_edicao");
		
		Vector topicos = new Vector();
		while(rset.next()) {
			id_topico = rset.getInt(1);			
			topicos.addElement(this.procurarTopico(id_forum,id_assunto,id_topico));		
		}
		stmt.close();    	
    	return topicos;	
	}
	
	
	public Topico procurarTopico(int id_forum,int id_assunto, int id_topico) throws SQLException {
		Statement stmt = con.createStatement();
		int numeroMensagens;
		Mensagem inicial,ultima;
		String titulo;
		
		ResultSet rset = stmt.executeQuery("select t.* from the ( select a.topicos from the (select f.assuntos from " +
				"forum f where f.id = "+id_forum+")a where a.id = "+id_assunto+")t where t.id = "+ id_topico );
		
		if(!rset.next()) return null;
		id_topico = rset.getInt(1);
		titulo = rset.getString(2);
		numeroMensagens = rset.getInt(4);
		inicial = this.procurarMensagemTopico(id_forum,id_assunto,id_topico,rset.getInt(5));
		ultima = this.procurarMensagemTopico(id_forum,id_assunto,id_topico,rset.getInt(6));		
		stmt.close();
		
		return  new Topico(id_topico,titulo,inicial,numeroMensagens,ultima);
	}

	
	
	public Vector getMensagensTopico(int id_forum, int id_assunto, int id_topico) throws SQLException {
		Statement stmt = con.createStatement();
		ResultSet rset;
		int id_mensagem;
		Vector top = new Vector();
		
		rset = stmt.executeQuery("SELECT m.id FROM the(select t.mensagens from the ( select a.topicos from the (" +
				"select f.assuntos from forum f where f.id = "+id_forum+")a where a.id = "+id_assunto+")t " +
				"where t.id = "+ id_topico + ")m ORDER BY m.data");
		
		while(rset.next()) {
        	id_mensagem = rset.getInt(1);
        	top.addElement(this.procurarMensagemTopico(id_forum,id_assunto,id_topico,id_mensagem));
        }
		stmt.close();		
        return top;
	}
	
	

	
	public void atualizarForum(Forum f) throws SQLException {
		Statement stmt = this.con.createStatement();		
        stmt.executeUpdate("UPDATE forum SET nome = '"+ f.getTitulo() +"' WHERE id = " + f.getID() + ";");
        stmt.close();
	}

	
	public void atualizarAssunto(int id_forum,Assunto a) throws SQLException {
		Statement stmt = this.con.createStatement(); 
        stmt.executeUpdate("UPDATE table (SELECT f.assuntos FROM forum f WHERE f.id = "+ id_forum+") SET titulo = '"+
        		          a.getTitulo() + "',descricao = '"+a.getDescricao()+"' WHERE id = " + a.getID() + ";");      
		stmt.close();
	}
	
	
	public void atualizarTopico(int id_forum, int id_assunto,Topico t) throws SQLException {
		Statement stmt = this.con.createStatement();
        stmt.executeUpdate("UPDATE table (SELECT a.topicos FROM THE(SELECT f.assuntos FROM forum f WHERE f.id = "+
				id_forum+") a WHERE a.id = "+id_assunto+")SET titulo = '"+ t.getTitulo() +"' WHERE id = " + 
				t.getID() );
        stmt.close();       
	}

	public void atualizarMensagemTopico(int id_forum, int id_assunto, int id_topico, Mensagem m) throws SQLException {
		Statement stmt = this.con.createStatement();
        stmt.executeUpdate("UPDATE table (SELECT t.mensagens FROM THE(SELECT a.topicos FROM THE(SELECT f.assuntos " +
        		"FROM forum f WHERE f.id = "+id_forum+") a WHERE a.id = "+id_assunto+") t WHERE t.id = "+id_topico+
        		"SET corpo = '"+ m.getCorpo() +"', data_edicao = SYSDATE WHERE id = " + m.getID() + ";");
        stmt.close();     
	}
	
	
	
	public void moverTopico(int id_assunto, int id_topico) throws SQLException {
		/*Statement stmt = this.con.createStatement();		
        stmt.executeUpdate("UPDATE topico SET id_assunto = '"+ id_assunto + " WHERE id_topico = " + id_topico + ";");
        stmt.close();*/
	}
	
	
	
	
	public void removerForum(int id_forum) throws SQLException {
		Statement stmt = this.con.createStatement();	
		stmt.executeUpdate("DELETE FROM TABLE (select assuntos from forum f where f.id = "+ id_forum +");");
        stmt.close();
	}

	
	public void removerAssunto(int id_forum, int id_assunto) throws SQLException {
		Statement stmt = this.con.createStatement();		
		stmt.executeUpdate("DELETE FROM TABLE (select mensagens from usuario u where u.login = p_login)");
		stmt.executeUpdate("DELETE FROM usuario WHERE usuario.login = p_login;");
		stmt.close();
	}

	
	public void removerTopico(int id_forum, int id_assunto, int id_topico) throws SQLException {
		Statement stmt = this.con.createStatement();		
		stmt.executeUpdate("EXECUTE removerTopico ("+ id_topico +");");
        stmt.close();
	}
	
	public void removerMensagemTopico(int id_forum, int id_assunto, int id_topico, int id_mensagem) throws SQLException {
		Statement stmt = this.con.createStatement();		
		stmt.executeUpdate("EXECUTE removerMensagemTopico ("+ id_mensagem +");");
        stmt.close();
	}
	

}
