package projeto;



public class Projeto {

	
	private int ID;
	private String nome;
	private String descricao;
	private String criador;
	private int votos;
	private int nota;
	private int numeroDeVisitas;
	private int numeroDeDownloads;
	private int porcentagemDeConclusao;
	private String dtDeCriacao;
	
	
	public Projeto(int id,String nome, String descricao, String criador, int votos, int nota, int 
			        numeroDeVisitas, int numeroDeDownloads, int porcentagemDeConclusao, String dtCriacao) {
		this.ID = id;
		this.nome = nome;
	    this.descricao = descricao;
	    this.criador = criador;
	    this.votos = votos;
	    this.nota = nota;
		this.numeroDeVisitas = numeroDeVisitas;
		this.numeroDeDownloads = numeroDeDownloads;
		this.porcentagemDeConclusao = porcentagemDeConclusao;
		this.dtDeCriacao = dtCriacao;
	}
	
	public Projeto(String nome, String descricao, String criador) {
		this.nome = nome;
		this.descricao = descricao;
		this.criador = criador;
	}
	
	
	
	public int getID() {
		return this.ID;
	}
	public String getNome() {
		return this.nome;
	}
	public String getDescricao() {
		return this.descricao;
	}
	public String getDtDeCriacao() {
		return this.dtDeCriacao;
	}
	public String getCriador() {
		return this.criador;
	}
	public int getVotos() {
		return this.votos;
	}
	public int getNota() {
		return this.nota;
	}
	public int getPorcentagemDeConclusao() {
		return this.porcentagemDeConclusao;
	}
	public int getNumeroDeDownloads() {
		return this.numeroDeDownloads;
	}
	public int getNumeroDeVisitas() {
		return this.numeroDeVisitas;
	}	
	
	
	
	public void setID(int id) {
		this.ID = id;
	}
	public void setNome(String nome) {
		this.nome = nome;
	}
	public void setDescricao(String descricao) {
		this.descricao = descricao;
	}
	public void setDtDeCriacao(String dtDeCriacao) {
		this.dtDeCriacao = dtDeCriacao;
	}
	/*public void setCriador(Usuario criador) {
		this.criador = criador;
	}*/
	public void setVotos(int votos) {
		this.votos = votos;
	}
	public void setNota(int nota) {
		this.nota = nota;
	}	
	public void setPorcentagemDeConclusao(int porcentagemDeConclusao) {
		this.porcentagemDeConclusao = porcentagemDeConclusao;
	}
	public void setNumeroDeDownloads(int numeroDeDownloads) {
		this.numeroDeDownloads = numeroDeDownloads;
	}
	public void setNumeroDeVisitas(int numeroDeVisitas) {
		this.numeroDeVisitas = numeroDeVisitas;
	}
		
	
	public void atualizarProjeto(Projeto p) {
		this.ID = p.getID();
		this.nome = p.getNome();
	    this.descricao = p.getDescricao();
	    this.criador = p.getCriador();
	    this.votos = p.getVotos();
	    this.nota = p.getNota();
		this.numeroDeVisitas = p.getNumeroDeVisitas();
		this.numeroDeDownloads = p.getNumeroDeDownloads();
		this.porcentagemDeConclusao = p.getPorcentagemDeConclusao();
		this.dtDeCriacao = p.getDtDeCriacao();		
	}
		
	
	public boolean equals(Object a)  {		
		if( a != null && this.ID == ((Projeto)a).getID() )  {
			return true;
		}
		return false;
	}		
	
}
