package projeto;

import java.sql.*;
import java.util.Vector;




public class RepositorioProjeto  implements IRepositorioProjeto {
	
	
	private Connection con;
	
	
	
	public RepositorioProjeto(Connection c) {
		this.con = c;
	}
	
	
	
	public Projeto adicionarProjeto(Projeto p) throws SQLException {
		Statement stmt = this.con.createStatement();
		ResultSet rset = stmt.executeQuery("SELECT id_usuario FROM usuario WHERE login = '" + p.getCriador() +"';");
		if(!rset.next()) return null;
		
    	int autor = rset.getInt(1);				
        stmt.executeUpdate("INSERT INTO projeto (nome,descricao,data_criacao,numero_de_visitas," +
        		           "numero_downloads,votos,nota,porcentagem_conclusao,ID_usuario) VALUES " +
        		           "('"+ p.getNome() +"','"+ p.getDescricao() +"',"+ "now() ,"+ p.getNumeroDeVisitas() +
        		           ","+ p.getNumeroDeDownloads() +","+ p.getVotos() +","+ p.getNota() +","+
        		           p.getPorcentagemDeConclusao() +","+ autor +");");
        
        rset = stmt.executeQuery("SELECT MAX(id_projeto) FROM projeto;");
		if(!rset.next()) return null;
		int id = rset.getInt(1);
				
		rset = stmt.executeQuery("SELECT * FROM projeto WHERE id_projeto = "+ id +";");
		if(!rset.next()) return null;
        
		p.setID(rset.getInt(1)); 
		p.setDtDeCriacao(rset.getString(4));
        stmt.close();
        return p;
	}	
	
	
	public void atualizarProjeto(Projeto p) throws SQLException {
		Statement stmt = this.con.createStatement();
		
        stmt.executeUpdate("UPDATE projeto SET nome = '"+ p.getNome() +"',descricao = '"+ p.getDescricao() +
        		           "',numero_de_visitas = " + p.getNumeroDeVisitas() +",numero_downloads = "+ 
        		           p.getNumeroDeDownloads() +",votos = "+ p.getVotos() +",nota = "+ p.getNota() +
        		           ",porcentagem_conclusao = "+ p.getPorcentagemDeConclusao() + 
        		           " WHERE ID_projeto = "+ p.getID() +";");
        System.out.println("UPDATE projeto SET nome = '"+ p.getNome() +"',descricao = '"+ p.getDescricao() +
        		           "',numero_de_visitas = " + p.getNumeroDeVisitas() +",numero_downloads = "+ 
        		           p.getNumeroDeDownloads() +",votos = "+ p.getVotos() +",nota = "+ p.getNota() +
        		           ",porcentagem_conclusao = "+ p.getPorcentagemDeConclusao() + 
        		           " WHERE ID_projeto = "+ p.getID() +";");
        stmt.close();
	}	
	
	
	public Vector getEsperaProjeto(int id_projeto) throws SQLException {
		Statement stmt = this.con.createStatement();
		Statement stmt2 = this.con.createStatement();
		ResultSet rset,rset2;
		int id_usuario;
		
		rset = stmt.executeQuery("SELECT id_usuario FROM esperaProjeto WHERE id_projeto = "+ id_projeto +";");
		
		Vector esp = new Vector();        
        while(rset.next()) {
        	id_usuario = rset.getInt(1);
        	rset2 = stmt2.executeQuery("SELECT login FROM usuario WHERE id_usuario = "+ id_usuario +";");
        	
        	rset2.next();
        	esp.addElement(rset2.getString(1));        	
        }
        stmt2.close();
        stmt.close();	
		
		return esp;
	}
	
	public void adicionarEsperaProjeto(int id_projeto, int id_usuario) throws SQLException {
		Statement stmt = this.con.createStatement();		
		stmt.executeUpdate("INSERT INTO esperaProjeto (id_usuario,id_projeto) VALUES ("
				           + id_usuario +","+ id_projeto +");");
		stmt.close();
	}
	
	public void removerEsperaProjeto(int id_projeto, int id_usuario) throws SQLException {
		Statement stmt = this.con.createStatement();		
		stmt.executeUpdate("DELETE FROM esperaProjeto  WHERE id_projeto = "+ id_projeto +" AND id_usuario = "+
				            id_usuario +";");	
		stmt.close();			
	}
	
	
	
	
	public void adicionarAdminProjeto(int id_projeto, int id_usuario) throws SQLException {
		Statement stmt = this.con.createStatement();		
		stmt.executeUpdate("INSERT INTO administra (id_usuario,id_projeto) VALUES ("
				           + id_usuario +","+ id_projeto +");");
		stmt.close();				
	}
	
	
	public void adicionarMembroProjeto(int id_projeto, int id_usuario) throws SQLException {
		Statement stmt = this.con.createStatement();		
		stmt.executeUpdate("INSERT INTO ehMembro (id_usuario,id_projeto) VALUES ("
				           + id_usuario +","+ id_projeto +");");
		stmt.close();		
	}
	
	
	public void removerAdminProjeto(int id_projeto, int id_usuario) throws SQLException{
		Statement stmt = this.con.createStatement();		
		stmt.executeUpdate("DELETE FROM administra  WHERE id_projeto = "+ id_projeto +" AND id_usuario = "+
				           id_usuario +";");	
		stmt.close();		
	}
	
	public void removerMembroProjeto(int id_projeto, int id_usuario) throws SQLException {
		Statement stmt = this.con.createStatement();		
		stmt.executeUpdate("DELETE FROM ehMembro  WHERE id_projeto = "+ id_projeto +" AND id_usuario = "+
				            id_usuario +";");	
		stmt.close();					
	}
	
	
	
	
	public Projeto procurarProjeto(int id) throws SQLException {
		Statement stmt = this.con.createStatement();
		
		ResultSet rset = stmt.executeQuery("SELECT * FROM projeto WHERE ID_projeto = "+ id +";");
		if(!rset.next()) return null;
		
		Statement stmt2 = this.con.createStatement(); 
		ResultSet rset2 = stmt2.executeQuery("SELECT login FROM usuario WHERE id_usuario = "+ rset.getInt(10) +";");
		String criador = "#ANONIMO#";
    	if(rset2.next()) criador = rset2.getString(1);
		
		Projeto p = new Projeto(id,rset.getString(2),rset.getString(3),criador,rset.getInt(7),rset.getInt(8),
				                rset.getInt(5),rset.getInt(6),rset.getInt(9),rset.getString(4));
		stmt.close();
		stmt2.close();
		
		return p;
	}
	
	
	public Vector getProjetos() throws SQLException {
		Statement stmt = this.con.createStatement();
		int id_projeto;
		Projeto p;
		
		ResultSet rset = stmt.executeQuery("SELECT id_projeto FROM projeto;");
		
		Vector projetos = new Vector();        
        while(rset.next()) {
        	id_projeto = rset.getInt(1);
        	p = this.procurarProjeto(id_projeto);
        	projetos.addElement(p);
        }
        stmt.close();	
		
		return projetos;
	}
	
	
	public Vector getProjetosAdministrados(int id_usuario) throws SQLException {
		Statement stmt = this.con.createStatement();
		int id_projeto;
		Projeto p;
		
		ResultSet rset = stmt.executeQuery("SELECT id_projeto FROM administra WHERE id_usuario = "+ id_usuario +";");
		
		Vector projetos = new Vector();        
        while(rset.next()) {
        	id_projeto = rset.getInt(1);
        	p = this.procurarProjeto(id_projeto);
        	projetos.addElement(p);
        }
        stmt.close();	
		
		return projetos;
	}	
	
	
	public Vector getProjetosMembro(int id_usuario) throws SQLException {
		Statement stmt = this.con.createStatement();
		int id_projeto;
		Projeto p;
		
		ResultSet rset = stmt.executeQuery("SELECT id_projeto FROM ehMembro WHERE id_usuario = "+ id_usuario +";");
		
		Vector projetos = new Vector();        
        while(rset.next()) {
        	id_projeto = rset.getInt(1);
        	p = this.procurarProjeto(id_projeto);
        	projetos.addElement(p);
        }
        stmt.close();	
		
		return projetos;
	}	
	
	
	public Vector getProjetosCriados(int id_usuario) throws SQLException {
		Statement stmt = this.con.createStatement();
		int id_projeto;
		Projeto p;
		
		ResultSet rset = stmt.executeQuery("SELECT id_projeto FROM projeto WHERE id_usuario = "+ id_usuario +";");
		
		Vector projetos = new Vector();        
        while(rset.next()) {
        	id_projeto = rset.getInt(1);
        	p = this.procurarProjeto(id_projeto);
        	projetos.addElement(p);
        }
        stmt.close();	
		
		return projetos;
	}	
	
	
	public Vector getAdministradoresProjeto(int id_projeto) throws SQLException {
		Statement stmt = this.con.createStatement();
		Statement stmt2 = this.con.createStatement();
		ResultSet rset,rset2;
		int id_usuario;
		
		rset = stmt.executeQuery("SELECT id_usuario FROM administra WHERE id_projeto = "+ id_projeto +";");
		
		Vector admin = new Vector();        
        while(rset.next()) {
        	id_usuario = rset.getInt(1);
        	rset2 = stmt2.executeQuery("SELECT login FROM usuario WHERE id_usuario = "+ id_usuario +";");
        	
        	rset2.next();
        	admin.addElement(rset2.getString(1));        	
        }
        stmt2.close();
        stmt.close();	
		
		return admin;
	}
	
	
	public Vector getMembrosProjeto(int id_projeto) throws SQLException {
		Statement stmt = this.con.createStatement();
		Statement stmt2 = this.con.createStatement();
		ResultSet rset,rset2;
		int id_usuario;
		
		rset = stmt.executeQuery("SELECT id_usuario FROM ehMembro WHERE id_projeto = "+ id_projeto +";");
		
		Vector membros = new Vector();        
        while(rset.next()) {
        	id_usuario = rset.getInt(1);
        	rset2 = stmt2.executeQuery("SELECT login FROM usuario WHERE id_usuario = "+ id_usuario +";");
        	
        	rset2.next();
        	membros.addElement(rset2.getString(1));        	
        }
        stmt2.close();        
        stmt.close();	
		
		return membros;
	}
		
	
	
	public void removerProjeto(int id) throws SQLException {
		Statement stmt = this.con.createStatement();
		
		stmt.executeUpdate("DELETE FROM administra  WHERE id_projeto = "+ id +";");
		stmt.executeUpdate("DELETE FROM ehMembro  WHERE id_projeto = "+ id +";");
		stmt.executeUpdate("DELETE FROM projeto WHERE ID_projeto = "+ id +";");
        stmt.close();
	}
	
	
	
	
	public static void main(String args[]) {
		
		try {
			Class.forName("org.gjt.mm.mysql.Driver");        
		    Connection con = DriverManager.getConnection("jdbc:mysql://notebook7/devware2","root","cinferno");

			RepositorioProjeto rep = new RepositorioProjeto(con);
			
			/*Projeto p = new Projeto("Projeto42", "totalmente excelente", "pabv");
			p = rep.adicionarProjeto(p);
			//System.out.println("entaum pegou");
			
			p = rep.procurarProjeto(p.getID());*/
			Projeto p = rep.procurarProjeto(1);
			Vector v = rep.getMembrosProjeto(1);
			
			if(p == null) System.out.println("null");
			else   {
				int size = v.size();
				for(int i = 0; i < size; i++) {
					
					System.out.println( (String)v.elementAt(i) );
				}
			}
			
			
		}
		catch(Exception e) {
			e.printStackTrace();			
		}
		
		
	}

}
