package usuario;



import exceptions.*;
import util.Mensagem;
import util.ICadastroMensagem;

import java.sql.SQLException;
import java.util.Vector;




public interface ICadastroUsuario {
	
	
	

	public boolean existeUsuario(String login) throws ObjetoNuloException,SQLException;
	
	public Usuario procurarUsuario(String login) 
	  throws ObjetoNuloException,UsuarioNaoExistenteException,SQLException;
	
	
	
	public Vector getUsuarios() throws SQLException;
	
	public Vector getMensagensPrivada(String login) 
	  throws ObjetoNuloException,UsuarioNaoExistenteException,SQLException;
	
	
	
	
	public void adicionarUsuario(Usuario u) throws ObjetoNuloException,UsuarioExistenteException,SQLException;
	
	public void atualizarUsuario(Usuario u) throws ObjetoNuloException,UsuarioNaoExistenteException,SQLException;
	
	
	
	public void adicionarMensagemPrivada(String login, Mensagem m) 
	  throws ObjetoNuloException,UsuarioNaoExistenteException,SQLException;
	
	public void removerMensagemPrivada(int id_mensagem) throws SQLException;
	
		
	
	public void removerUsuario(String login, ICadastroMensagem cadMen) 
	  throws ObjetoNuloException,UsuarioNaoExistenteException,SQLException;
	                                                   
}
