package util;



import java.io.*;
import java.sql.*;


public class Avatar {

	
	private Connection con;
	
	public Avatar(Connection c) {
		this.con = c;		
	}

	
	public void insertImage(File img, int userID) throws IllegalArgumentException, FileNotFoundException{
	
	String sql = "UPDATE TABLE Usuario SET avatar=? WHERE id_usuario=" + userID;
	PreparedStatement ps;
	try {
	
		ps = con.prepareStatement(sql);
		ps.setBinaryStream(1,new FileInputStream(img),(int)img.length());
		ps.execute();
		System.out.println("Arquivo inserido com sucesso!!");
	} catch (SQLException e) {
		System.err.println(e.getLocalizedMessage());
		e.printStackTrace();
	}
	
}
	
	public void getAvatar(String nome/*int userID*/) throws NoDataException {
		
		
		
		try {		
			File arq2 = new File("h:\\public_html\\avatar");
			if(!arq2.exists()) {
				  arq2.mkdir();	
				}
			
			File img = new File(arq2.getAbsolutePath()+"\\" +nome);
			
			if(!img.exists()) {
				
			
			
			FileOutputStream fos = new FileOutputStream(img);
			//String sql = "SELECT avatar FROM usuario WHERE id_usuario=?";
			String sql = "SELECT binaryfile FROM uploads WHERE filename=?";
			PreparedStatement ps = con.prepareStatement(sql);	
			ps.setString(1,nome/*userID*/);//era setInt
			ResultSet rs = ps.executeQuery();
	
			if(rs.next()) {
				Blob b = rs.getBlob("binaryfile");
				int length = (int)b.length();	
				System.out.println("o numero de bytes foi -> " + length);
				InputStream fs = (b.getBinaryStream());
			 
				/*byte teste[ ] = fotoBlob.getBytes(1l,
				(int)fotoBlob.length());
						if (teste != null) {
						result =
						(Image)Toolkit.getDefaultToolkit().createImage(teste);
				*/
				
				byte mb[] = b.getBytes(1,(int)b.length());
				byte br;
				for(int abcdef = 0; abcdef < mb.length; abcdef++) {
					if((br=(byte)fs.read())!=-1)  	{
						mb[abcdef] = br;	
					}
				}
				fos.write(mb);
				fos.close();
			} else {
				System.out.println("nao tem avatar!!!!!");
			    throw new NoDataException(); 	
			}
		}
		} catch (FileNotFoundException e) {			
			e.printStackTrace();
		} catch (SQLException e) {		
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
	}
	
	public static void main (String args []) {
		try {
		Class.forName("oracle.jdbc.driver.OracleDriver");
		java.sql.Connection con = java.sql.DriverManager.getConnection("jdbc:oracle:thin:@oracle.cin.ufpe.br:1521:dbgrad","if68520509","sixteam2006");
		
		util.Avatar av = new util.Avatar (con);
		av.getAvatar("PICT0008.JPG");
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}

class NoDataException extends Exception {
	NoDataException() {
		super("The data solicited isnt in database.");
	}
}


