package util;


import java.util.Vector;
import java.sql.SQLException;



public interface IRepositorioMensagem {
	
	
	public Mensagem adicionarMensagem(Mensagem m) throws SQLException;
	
	public void adicionarMensagemPrivada(int id_usuario, int id_mensagem) throws SQLException;
	
	public void adicionarComentarioProjeto(int  id_projeto, int id_mensagem) throws SQLException;
	
	public void adicionarRecadoProjeto(int  id_projeto, int id_mensagem) throws SQLException;
	
	public void adicionarMensagemTopico(int id_topico, int id_mensagem) throws SQLException;	
		
	
	public void atualizarMensagem(Mensagem m) throws SQLException;
	
	public void deletarAutorMensagem(String login) throws SQLException;
	
	
	public Mensagem procurarMensagem(int id) throws SQLException;
		
	public Vector getMensagensPrivada(int id_usuario) throws SQLException;
	
	public Vector getComentariosProjeto(int id_projeto) throws SQLException;
	
	public Vector getRecadosProjeto(int id_projeto) throws SQLException;
	
	public Vector getMensagensTopico(int id_topico) throws SQLException;
	
	
	public void removerMensagem(int id_mensagem) throws SQLException;
	
	public void removerMensagemPrivada(int id_usuario, int id_mensagem) throws SQLException;
	
	public void removerComentarioProjeto(int id_projeto, int id_mensagem) throws SQLException;
	
	public void removerRecadoProjeto(int id_projeto, int id_mensagem) throws SQLException;
	
	public void removerMensagemTopico(int id_topico, int id_mensagem) throws SQLException;
		
	
}
