package forum;


import util.Mensagem;
import java.util.Vector;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;





public interface IRepositorioForum  {
	
	

	public void adicionarForum(Forum f) throws SQLException;
	
	public void adicionarAssunto(int id_forum, Assunto a) throws SQLException;
	
	public void adicionarTopico(int id_forum, int id_assunto, Topico t) throws SQLException;
		
	public void adicionarMensagemTopico(int id_forum,int id_assunto,int id_topico,Mensagem m) throws SQLException;


	
	public Vector getForuns() throws SQLException;
	
	public Forum procurarForum(int id_forum) throws SQLException;
	
	public Assunto procurarAssunto(int id_forum,int id_assunto) throws SQLException;
	
	public Mensagem procurarMensagemTopico(int id_forum,int id_assunto,int id_topico,int id_mensagem) throws SQLException;
	
	
	public Vector getTopicosAssunto(int id_forum, int id_assunto) throws SQLException;
	
	
	public Topico procurarTopico(int id_forum,int id_assunto, int id_topico) throws SQLException ;

		
	public Vector getMensagensTopico(int id_forum, int id_assunto, int id_topico) throws SQLException;
	

	
	
	public void atualizarForum(Forum f) throws SQLException;
	
	public void atualizarAssunto(int id_forum,Assunto a) throws SQLException;
		
	public void atualizarTopico(int id_forum, int id_assunto,Topico t) throws SQLException;

	public void atualizarMensagemTopico(int id_forum, int id_assunto, int id_topico, Mensagem m) throws SQLException;
	
		
	
	public void moverTopico(int id_assunto, int id_topico) throws SQLException;
	
	
	
	
	public void removerForum(int id_forum) throws SQLException;
	
	public void removerAssunto(int id_forum, int id_assunto) throws SQLException;
	
	public void removerTopico(int id_forum, int id_assunto, int id_topico) throws SQLException;
	
	public void removerMensagemTopico(int id_forum, int id_assunto, int id_topico, int id_mensagem) throws SQLException;
	



}		

	