package projeto;


import java.util.Vector;
import java.sql.SQLException;



public interface IRepositorioProjeto {

	
	public Projeto adicionarProjeto(Projeto p) throws SQLException;
	
	public void atualizarProjeto(Projeto p) throws SQLException;

	
	public Vector getEsperaProjeto(int id_projeto) throws SQLException;
			
	public void adicionarEsperaProjeto(int id_projeto, int id_usuario) throws SQLException;
	
	public void removerEsperaProjeto(int id_projeto, int id_usuario) throws SQLException;
	

	public void adicionarAdminProjeto(int id_projeto, int id_usuario) throws SQLException;
	
	public void adicionarMembroProjeto(int id_projeto, int id_usuario) throws SQLException;
	
	public void removerAdminProjeto(int id_projeto, int id_usuario) throws SQLException;
	
	public void removerMembroProjeto(int id_projeto, int id_usuario) throws SQLException;
	
		
	public Projeto procurarProjeto(int id_projeto) throws SQLException;
	
	public Vector getProjetos() throws SQLException;
		
	public Vector getProjetosAdministrados(int id_usuario) throws SQLException;
	
	public Vector getProjetosMembro(int id_usuario) throws SQLException;
	
	public Vector getProjetosCriados(int id_usuario) throws SQLException;
	
	public Vector getAdministradoresProjeto(int id_projeto) throws SQLException;
	
	public Vector getMembrosProjeto(int id_projeto) throws SQLException;
	
	public void removerProjeto(int id_projeto) throws SQLException;
	
}
