package usuario;


import java.sql.*;
import java.util.Vector;

import util.Mensagem;


public interface IRepositorioUsuario {
	

	public void adicionarUsuario(Usuario u) throws SQLException;
	
	
	public void adicionarMensagemPrivada(String login, Mensagem m) throws SQLException;
	
	
	
	

	public Endereco pegarEndereco(ResultSet rset) throws SQLException;
	
	public String[] pegarTelefones(ResultSet rset) throws SQLException;
		
	
	public Usuario procurarUsuario(String login) throws SQLException;
	
	
	
	public Mensagem procurarMensagemPrivada(ResultSet rset) throws SQLException;
	
	
	public Vector getMensagensPrivada(String login) throws SQLException;
	
	
	
	
	public Vector getUsuarios() throws SQLException;
		
	
	public void atualizarUsuario(Usuario u) throws SQLException;
	
	
		
	public void removerUsuario(String login) throws SQLException;
	public void removerMensagemPrivada(int id_mensagem) throws SQLException;
	
}