package usuario;


import java.sql.*;
import java.util.Vector;

import projeto.Projeto;
import util.Mensagem;




public class RepositorioUsuario  implements IRepositorioUsuario {
	
	
	
	private Connection con;
	
	
	
	public RepositorioUsuario(Connection c)  {
		this.con = c;
	}
	
	
	
	public void adicionarUsuario(Usuario u) throws SQLException {
 		Statement stmt = this.con.createStatement();	
 		
 		if(u.getDtNascimento() == null || u.getDtNascimento().equals("")) {
 			u.setDtNascimento("SYSDATE");
 		} else {
 			u.setDtNascimento("'"+ u.getDtNascimento() +"'");
 		}
 		
 		Endereco e = u.getEndereco();
		
 		System.out.println("INSERT INTO usuario VALUES  ('"+ u.getLogin() +"','"+ u.getSenha() +"','"+ u.getNome() +
		           "','"+ u.getEmail() +"','"+ u.getDados() +"','"+ u.getSexo() +"','usuario', 0, SYSDATE,"+
		           "SYSDATE, -1, tel_array('"+u.getTelefone()[0] +
		           "','"+ u.getTelefone()[1] +"','"+ u.getTelefone()[2] +"'), endereco_tp('" +e.getRua() +
		           "','"+ e.getBairro() +"','"+ e.getCidade() +"','"+ e.getCep() +"','"+ e.getUF() +"','"+ 
		           e.getPais() +"'), mensagem_privada_nested() )");
 		
 		stmt.executeUpdate("INSERT INTO usuario VALUES  ('"+ u.getLogin() +"','"+ u.getSenha() +"','"+ u.getNome() +
				           "','"+ u.getEmail() +"','"+ u.getDados() +"','"+ u.getSexo() +"','usuario', 0, SYSDATE,"+
				           "to_date("+ u.getDtNascimento()+",'dd/mm/yyyy'), -1, tel_array('"+u.getTelefone()[0] +
				           "','"+ u.getTelefone()[1] +"','"+ u.getTelefone()[2] +"'), endereco_tp('" +e.getRua() +
				           "','"+ e.getBairro() +"','"+ e.getCidade() +"','"+ e.getCep() +"','"+ e.getUF() +"','"+ 
				           e.getPais() +"'), mensagem_privada_nested() )");
				stmt.close();		
	}
	
	
	public void adicionarMensagemPrivada(String login, Mensagem m) throws SQLException {
		Statement stmt = this.con.createStatement();
		stmt.executeUpdate("INSERT INTO THE(SELECT u.mensagens FROM usuario u WHERE u.login = '"+ login +"')"+
                           "VALUES  ('"+ m.getCorpo() +"', SYSDATE, SYSDATE, (SELECT REF(u) FROM usuario u " +
                           "WHERE u.login = '"+ m.getAutor() +"'), idMensagemPrivada.nextVal)");
		stmt.close();		
	}
	
	
	
	
	

	public Endereco pegarEndereco(ResultSet rset) throws SQLException {		
        String rua = rset.getString(1);
        String bairro = rset.getString(2);
        String cid = rset.getString(3);
        String cep = rset.getString(4);
        String uf = rset.getString(5);
        String pais = rset.getString(6);        
        return new Endereco(rua,bairro,cid,cep,uf,pais);
	}
	
	public String[] pegarTelefones(ResultSet rset) throws SQLException {		
        String fone1 = rset.getString(1);
        String fone2 = rset.getString(1);
        String fone3 = rset.getString(1);        
        String fones[] = new String[3];
        fones[0] = fone1;
        fones[1] = fone2;
        fones[2] = fone3;
        return fones;        
	}
		
	
	public Usuario procurarUsuario(String login) throws SQLException {
        Statement stmt = con.createStatement();            
                
        ResultSet rset = stmt.executeQuery("SELECT u.endereco.rua,u.endereco.bairro,u.endereco.cidade," +
        		                           "u.endereco.cep,u.endereco.uf,u.endereco.pais FROM usuario u " +
        		                           "WHERE login = '"+ login +"'");
        System.out.println(1);
        if(!rset.next()) return null;
        Endereco e = this.pegarEndereco(rset);             
        System.out.println(2);
        rset = stmt.executeQuery("SELECT u.telefones FROM usuario u WHERE login = '"+ login +"'");
        if(!rset.next()) return null;
        String fones[] = this.pegarTelefones(rset);             
        
        System.out.println(3);
        rset = stmt.executeQuery("SELECT * FROM usuario WHERE login = '" + login + "'");
        if(!rset.next()) return null; 
        String senha = rset.getString(2);
        String nome = rset.getString(3);
        String email = rset.getString(4);
        String dados = rset.getString(5);
        String sexo = rset.getString(6); 
        String rank = rset.getString(7);
        int numMen = rset.getInt(8); 
        String dtEnt = rset.getString(9);
        String dtNasc = rset.getString(10);
        
        int id_avatar = rset.getInt(11);
        
        stmt.close();
        return new Usuario(login,senha,nome,email,dados,sexo.charAt(0),rank,numMen,dtEnt,dtNasc,id_avatar,fones,e);
    }
	
	
	
	
	public Mensagem procurarMensagemPrivada(ResultSet rset) throws SQLException {
		Statement stmt = con.createStatement();
				
		if(!rset.next()) return null;
		String corpo = rset.getString(1);
    	String data = rset.getString(2);
    	String edit = rset.getString(3);
    	int id = rset.getInt(5);    	 
    	String autor = rset.getString(4);
    	stmt.close();
    	
    	return new Mensagem(id,autor,corpo,data,edit);	
	}
	
	
	public Vector getMensagensPrivada(String login) throws SQLException {
		Statement stmt = con.createStatement();
		Statement stmt2 = con.createStatement();
		ResultSet rset;
		int id_mensagem;
		Vector top = new Vector();
		
		rset = stmt.executeQuery("SELECT m.id FROM THE(SELECT u.mensagens FROM usuario u WHERE u.login = '"+ login +
				                 "') m  ORDER BY m.data");
		while(rset.next()) {
        	id_mensagem = rset.getInt(1);
        	ResultSet rset2 = stmt2.executeQuery("SELECT m.* FROM THE(select u.mensagens from usuario u where u.login = '"+
        			login+"') m  WHERE m.id = "+id_mensagem);
    		
        	top.addElement(this.procurarMensagemPrivada(rset2));
        }
		stmt.close();		
        return top;
	}
	
	
	
	
	
	public Vector getUsuarios() throws SQLException {
		Statement stmt = this.con.createStatement();
		String login;
		
		ResultSet rset = stmt.executeQuery("SELECT login FROM usuario;");
		
		Vector usuarios = new Vector();        
        while(rset.next()) {
        	login = rset.getString(1);
        	usuarios.addElement(login);
        }
        stmt.close();	
		
		return usuarios;		
	}
		
	
	public void atualizarUsuario(Usuario u) throws SQLException {
		Statement stmt = this.con.createStatement();	
		
		if(u.getDtNascimento() == null || u.getDtNascimento().equals("")) {
 			u.setDtNascimento("SYSDATE");
 		} else {
 			u.setDtNascimento("'"+ u.getDtNascimento() +"'");
 		}
		
		Endereco e = u.getEndereco();
		stmt.executeUpdate("UPDATE usuario SET senha = '"+ u.getSenha() +"', nome = '"+ u.getNome() +"', email = '"+
		                   u.getEmail() +"', dados = '"+ u.getDados() +"', sexo = '"+ u.getSexo() +
		                   "',  data_nascimento = "+ u.getDtNascimento() +", idAvatar = "+ u.getIDAvatar() +
		                   ", rank = '"+ u.getRank() +"', telefones = tel_array('"+ u.getTelefone()[0] +"','"+
		                   u.getTelefone()[1] +"','"+ u.getTelefone()[2] +"'), endereco_tp('"+  e.getRua() +"','"+ 
		                   e.getBairro() +"','"+ e.getCidade() +"','"+ e.getCep() +"','"+ e.getUF() +"','"+
		                   e.getPais() +"') WHERE login = '"+ u.getLogin() +"'" );	
    	stmt.close();		
	}
	
	
	
		
	public void removerUsuario(String login) throws SQLException {
		Statement stmt = this.con.createStatement();	
		stmt.executeUpdate("DELETE FROM TABLE (SELECT u.mensagens FROM usuario u) mensagens from usuario u where u.login = '"+ login +"')");
		stmt.executeUpdate("DELETE FROM usuario WHERE usuario.login = '"+ login +"'");
		stmt.close();		
	}
	
	public void removerMensagemPrivada(int id_mensagem) throws SQLException {
		Statement stmt = this.con.createStatement();	
		stmt.executeUpdate("DELETE FROM mensagensPrivadas WHERE id = "+ id_mensagem);
		stmt.close();		
	}
	
	
	
	public static void main (String args[]) {
		try {
			Class.forName("oracle.jdbc.driver.OracleDriver");        
		    Connection c = DriverManager.getConnection("jdbc:oracle:thin:@oracle.cin.ufpe.br:1521:dbgrad", 
		    		                                     "if68520509", "sixteam2006");

		    
			RepositorioUsuario rep = new RepositorioUsuario(c);
			
			Endereco e = new Endereco("marilia","jsp","recife","50790020","PE","Brasil");
			String teles[] = new String[3];	
			teles[0] = "";
			teles[1] = "";
			teles[2] = "";
			Usuario u = new Usuario("sss7","1986");
			u.setNome("pablo");
			u.setEmail("asdlguasdi");
			u.setEndereco(e);
			u.setTelefone(teles);
			Mensagem m = new Mensagem("sss5","kljasdgklasdgv");
			rep.adicionarMensagemPrivada("pabv",m);
			
			Vector v = rep.getMensagensPrivada("pabv");
			
			//rep.adicionarUsuario(u);
			/*
			Statement stmt = c.createStatement();	
	 		
	 		if(u.getDtNascimento() == null || u.getDtNascimento().equals("")) {
	 			u.setDtNascimento("SYSDATE");
	 		} else {
	 			u.setDtNascimento("'"+ u.getDtNascimento() +"'");
	 		}
	 		
	 		//Endereco e = u.getEndereco();
			stmt.executeUpdate("EXEC criarUsuarioSimples ('"+ u.getLogin() +"','"+ u.getSenha() +"','"+ u.getNome() +"','"+
					           u.getEmail() +"')" );			
			stmt.close();		
			//e.setBairro("jglasdi")
			///Usuario u2 = rep.procurarUsuario("pabv");
			//u2.setSenha("19127866");
			//u2.setEndereco(e);
			//rep.atualizarUsuario(u2);
			*/
			Usuario u2 = rep.procurarUsuario("pabv");
			if(v != null && v.elementAt(1) != null) System.out.println( ((Mensagem)(v.elementAt(1))).getAutor() );
			else System.out.println("null");
			
			
		
		
		}
		catch (Exception e) {
			e.printStackTrace();
		}	
		
		
		
		
		
	}
}
