package usuario;





public class Usuario  {
	
	private int ID;
	private String login;
	private String senha;
	
	private String nome;
	private String dados;
	private char sexo;
	private int idAvatar;
	private String email;
	private String[] telefone;
	private Endereco endereco;
	private String dtEntrada;
	private String dtNascimento;
	private String rank;
	private int numeroMensagens;
	
	
	
	public Usuario(String l, String s)  {
		this.login = l;
		this.senha = s;		
	}
	
	
	public Usuario(String login, String senha, String nome, String email, String dados, char sexo, String rank, 
			       int numeroMensagens, String dtEntrada, String dtNascimento,int avatar, String[] telefone,
			       Endereco endereco) {
		this.login = login;
		this.senha = senha;
		this.idAvatar = avatar;
		this.nome = nome;
		this.sexo = sexo;
		this.rank = rank;
		this.dados = dados;
		this.email = email;
		this.telefone = telefone;
		this.endereco = endereco;
		this.dtEntrada = dtEntrada;
		this.dtNascimento = dtNascimento;
		this.numeroMensagens = numeroMensagens;
	}
	
	
	
	
	public static String DATETIMEtoDATANORMAL(String datetime) {
		// "YYYY-MM-DD HH:MM:SS.DS"
		String retorno = "";
		String ano = datetime.substring(0,4);
		String mes = datetime.substring(5,7);
		String dia = datetime.substring(8,10);
		String hora = datetime.substring(11,19);
		
		String mesExt = "";
		int m = Integer.parseInt(mes);
		
		switch(m) {
			case 1: mesExt = "Jan";
			case 2: mesExt = "Fev";
			case 3: mesExt = "Mar";
			case 4: mesExt = "Abr";
			case 5: mesExt = "Mai";
			case 6: mesExt = "Jun";
			case 7: mesExt = "Jul";
			case 8: mesExt = "Ago";
			case 9: mesExt = "Set";
			case 10: mesExt = "Out";
			case 11: mesExt = "Nov";
			case 12: mesExt = "Dez";	
		}
		
		retorno = dia + " " + mesExt + " " + ano + "  " + hora;	
		return retorno;	
	}
	
	
	
	
	
	public int getID() {
		return this.ID;
	}
	public String getLogin() {
		return this.login;
	}
	public String getSenha() {
		return this.senha;
	}
	public String getNome() {
		return this.nome;
	}
	public String getDados() {
		return this.dados;
	}
	public int getIDAvatar() {
		return this.idAvatar;
	}
	public char getSexo() {
		return this.sexo;
	}
	public String getEmail() {
		return this.email;
	}
	public String[] getTelefone() {
		return this.telefone;
	}
	public Endereco getEndereco() {
		return this.endereco;
	}
	public String getDtNascimento() {
		return this.dtNascimento;
	}
	public String getDtEntrada() {
		return this.dtEntrada;
	}
	public String getRank() {
		return this.rank;
	}
	public int getNumeroMensagens() {
		return this.numeroMensagens;
	}

	
	/*public void setID(int id) {
		this.ID = id;
	}
	public void setLogin(String login) {
		this.login = login;
	}	*/
	public void setSenha(String senha) {
		this.senha = senha;
	}	
	public void setNome(String nome) {
		this.nome = nome;
	}
	public void setDados(String dados) {
		this.dados = dados;
	}	
	public void setIDAvatar(int avatar) {
		this.idAvatar = avatar;
	}
	public void setSexo(char sexo) {
		this.sexo = sexo;
	}	
	public void setEmail(String email) {
		this.email = email;
	}
	public void setTelefone(String[] telefone) {
		this.telefone = telefone;
	}	
	public void setEndereco(Endereco endereco) {
		this.endereco = endereco;
	}	
	public void setDtNascimento(String dtNascimento) {
		this.dtNascimento = dtNascimento;
	}
	public void setDtEntrada(String dtEntrada) {
		this.dtEntrada = dtEntrada;
	}
	public void setRank(String rank) {
		this.rank = rank;
	}
	public void setNumeroMensagens(int numero) {
		this.numeroMensagens = numero;
	}
	
	
	public void atualizarUsuario(Usuario u) {
		this.ID = u.getID();
		this.login = u.getLogin();
		this.senha = u.getSenha();
		this.nome = u.getNome();
		this.sexo = u.getSexo();
		this.email = u.getEmail();
		this.telefone = u.getTelefone();
		this.endereco = u.getEndereco();
		this.dtEntrada = u.getDtEntrada();
		this.dtNascimento = u.getDtNascimento();
		this.numeroMensagens = u.getNumeroMensagens();
	}
	
	
	public boolean equals(Object a) {		
		if( a != null && this.login.equals(((Usuario)a).getLogin()) )  {
			return true;
		}
		return false;
	}	
	
	
	
	
	

}
